#include "definition.inc"
#declare epaisseurTraits=0.03;

 
couleurFond(255,255,255)

#declare c=5  
#declare n=3 // doit tre infrieur  4 pour ne pas dpasser 
			// les limites du logiciel
// l'utilisateur dcide ici la longueur du ct du cube et le niveau
// du fractal qu'il dsire voir. 

uneCamera(<2*c,2*c,2*c>,<c/2,c/2,c/2>)

	uneLumiere(<2*c,2*c,2*c>)
//la camra et la lumire se positionnent en fonction de la longueur 
//du ct, ce qui a pour consquence que le fractal semble toujours
// tre de la mme grosseur, mais cela permet de toujours le voir
// en entier.

#macro Fractal(n,c)
	#declare Fractal0 = object
		{unPrisme (<0,0,0>,<c,c,c>)}
	#if (n = 0)
		object {Fractal0}
	#else // du #if (n = 0 )
		#local Fract = Fractal (n - 1, c)
		union 
		{	#local X = 0;
			#local Y = 0;
			#local Z = 0;
			#while (Z<3)
				#if (Y*X=1)
					#declare Y = Y + 1
				#else
					object {Fract translate <X*c, Y*c, Z*c>}
					#if (Y < 2)
						#declare Y = Y+1
					#else
						#declare Y = 0
						#declare X = X+1
					#end // fin du #if (Y < 2)
				#end // fin du #if(Y*X=1)
				
				#if(X=3)
					#declare Z = Z+1
					#declare X = 0
				#end // fin du #if (X=3)
				#if(Z*Y=1)
					#declare Y = Y+1
				#end // fin du #if(Z*Y=1)
				#if(Z*X=1)
					#declare X = X+1
				#end //fin du #if(Z*X=1)
			#end // fin du while
			scale (1/3)
			couleur(220,50,90,0) // l'utilisateur peut ici changer la couleur du fratal selon ses caprices

		}//fin de l'union
	#end // fin du #if
	
#end //fin de la macro

Fractal (n, c) // appelle la macro
 